@echo off
title Starte ... "%~n0"
color 1f
setlocal enabledelayedexpansion

set power=0
if exist %temp%\%~n0.ps1 del %temp%\%~n0.ps1
for /f "tokens=*" %%l in ('type "%~f0"') do (
  if !power!==0 (
    if "%%l"=="*** Ab hier PowerShell ***" set power=1
  ) else (
    echo %%l >> "%temp%\%~n0.ps1"
  )
)
cls
rem echo Starte "%~n0" 
title "%~n0" läuft  ...
powershell -NoProfile -ExecutionPolicy Bypass -File "%temp%\%~n0.ps1" %*
rem TIMEOUT /T 30 /nobreak 
del "%temp%\%~n0.ps1"
rem timeout /t 30
rem pause
exit /b

*** Ab hier PowerShell ***
# Show running .NET-Version
# Stop-Process -Name notepad -Force -ErrorAction SilentlyContinue
$execruntime = [System.Reflection.Assembly]::GetExecutingAssembly().ImageRuntimeVersion
#
$ExportPath = $env:TEMP
$ExportFile = "user-info-$env:Username@$env:computername.txt"
Remove-Item $ExportPath\$ExportFile -Force -ErrorAction SilentlyContinue
#

# ---- Ausgabe --- START ------ 
$DateTXT = Get-Date -format "dd.MM.yyyy - HH:mm:ss tt"
Write-Output "------------------------------------------------------------------" | Out-File "$ExportPath\$ExportFile" -Encoding utf8
Write-Output "User-Info Tool - Ver. 1.2.25 (12.01.2024) / .NET Runtime $execruntime" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "Download https:\\www.hekret.de\pcinfo" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "------------------------------------------------------------------`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
# Write-Output "`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "Erstellt von Benutzer '$env:userdomain\$env:USERNAME @ $env:computername'`r`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Write-Output "Datensatz erstellt am $DateTXT`r`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#

Write-Host "------------------------------------------------------------------"
Write-Host "User-Info Tool - Ver. 1.2.25 (12.01.2024) / .NET Runtime $execruntime"
Write-Host "Download https:\\www.hekret.de\pcinfo"
Write-Host "------------------------------------------------------------------`r`n"

# --- Info Machine / User --- START ---
$machinename = (Get-CimInstance -Class:Win32_Computersystem).Name
$domain = (Get-CimInstance Win32_ComputerSystem).Domain

# ActiveDirectory Site abfragen und Fehler abfangen.
try {
    $adsite = [System.DirectoryServices.ActiveDirectory.ActiveDirectorySite]::GetComputerSite().Name
    }
    catch
    {
    # Write-Host $PSItem.Exception.Message
    Set-Variable -Name adsite -Value "-"
    }
#
#
$dr = Get-CimInstance -Class win32_computersystem | Select-Object -ExpandProperty domainrole
$domainrole = switch ($dr) {
    0 {"Standalone Workstation"} 
    1 {"Member Workstation"} 
    2 {"Standalone Server"} 
    3 {"Member Server"} 
    4 {"Backup Domain Controller"} 
    5 {"Primary Domain Controller"} 
    default {"Unknown"} 
    } # end switch



write-Output "
Domain Machine Info:`
    Computername: ............... $machinename`
    ActiveDirectory: ............ $domain`
    Site: ....................... $adsite`
    Domain Role: ................ $domainrole`
`
Domain User Info:`
    ActiveDirectory: ............ $env:userdomain`
    LogonServer: ................ $env:logonserver`
    UserName: ................... $env:USERNAME`
    `
    `
    " | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append

# --- Info Machine / User --- END ---

# Write-Host "Status:`n"
Write-Host "collecting Data ...  / sammle Daten ...`r`n"
#
# -------------------  User Folder Paths / Benutzerordner Pfade ---------------- START -------------------
Write-Host "User Folder Paths / Benutzerordner Pfade `n"
Write-Output "---------- User Folder Paths / Benutzerordner Pfade ---------- START --------------------"  | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append

# https://docs.microsoft.com/en-us/dotnet/api/system.environment.specialfolder?redirectedfrom=MSDN&view=netcore-3.1
#
# Write-Host Home: $env:HOME
# Write-Host HomeDrive: $env:HOMEDRIVE
# Write-Host Homepath: $env:HOMEPATH
# Write-Host HomeShare: $env:HOMESHARE

# UserProfile Folder
$CurrUserProfile=[environment]::getfolderpath("UserProfile")

# Folders under "UserProfile"
$CurrUserDesktop=[environment]::getfolderpath("Desktop")
# $CurrUserDesktop=[environment]::getfolderpath("DesktopDirectory")
$CurrUserDocuments=[environment]::getfolderpath("MyDocuments")
# $CurrUserPersonalDocs=[environment]::getfolderpath("Personal") # Documents
$CurrUserPictures=[environment]::getfolderpath("MyPictures")
$CurrUserMusic=[environment]::getfolderpath("MyMusic")
$CurrUserVideos=[environment]::getfolderpath("MyVideos")
$CurrUserFavorites=[environment]::getfolderpath("Favorites")

# User Folders "Appdata\Roaming" / "Appdata\Local"
$CurrUserAppdata=[environment]::getfolderpath("ApplicationData")
$CurrUserAppDataLocal=[environment]::getfolderpath("LocalApplicationData")
# User Folders under "Appdata\Roaming"
$CurrUserTemplates=[environment]::getfolderpath("Templates")
$CurrUserStartup=[environment]::getfolderpath("Startup")
$CurrUserRecentList=[environment]::getfolderpath("Recent")
$CurrUserSendTo=[environment]::getfolderpath("SendTo")
$CurrUserNetShortcuts=[environment]::getfolderpath("NetworkShortcuts")
$CurrUserStartmenu=[environment]::getfolderpath("StartMenu")
$CurrUserStartmenuProgs=[environment]::getfolderpath("Programs")
$CurrUserStartmenuAdminTools=[environment]::getfolderpath("AdminTools")

# User Folders under / "Appdata\Local"
$CurrUserInetCache=[environment]::getfolderpath("InternetCache")
$CurrUserInetCookies=[environment]::getfolderpath("Cookies")
$CurrUserHistory=[environment]::getfolderpath("History")
$CurrUserBurn=[environment]::getfolderpath("CDBurning")
$CurrUserTMP = [System.Environment]::GetEnvironmentVariable('TMP','User')
$CurrUserTEMP = [System.Environment]::GetEnvironmentVariable('TEMP','User')
# $CurrUserPrtShort=[environment]::getfolderpath("PrinterShortcuts")




write-Output "`
/--------------------------\ `
`
Home: ........ $env:HOME`
HomeDrive: ... $env:HOMEDRIVE`
Homepath: .... $env:HOMEPATH`
HomeShare: ... $env:HOMESHARE`
`
\--------------------------/
`
/--------------------------\ `
`
# Current User Profile Folders`
`
User Profile / Benutzerprofil: ... $CurrUserProfile
Desktop: ......................... $CurrUserDesktop
Documents / Dokumente: ........... $CurrUserDocuments
Pictures / Bilder: ............... $CurrUserPictures
Music: ........................... $CurrUserMusic
Videos: .......................... $CurrUserVideos
Favorites / Favoriten: ........... $CurrUserFavorites
`
Application Data / Anwendungsdaten: ................ $CurrUserAppdata
local Application Data / lokale Anwendungsdaten: ... $CurrUserAppDataLocal
`
Templates / Vorlagen: ........................ $CurrUserTemplates
Recent / zuletzt Verwendet: .................. $CurrUserRecentList
Send To / Senden an: ......................... $CurrUserSendTo
Network Shortcuts / Netzwerkverknüpfungen: ... $CurrUserNetShortcuts
Startmenu / Startmenü: ....................... $CurrUserStartmenu
Startmenu Programs / Startmenü Programme: .... $CurrUserStartmenuProgs
Startup / Autostart: ......................... $CurrUserStartup
Administrative Tools / Administrator Tools: .. $CurrUserStartmenuAdminTools
`
CD/DVD Temporary Burn Folder: ... $CurrUserBurn`
History / Verlauf: .............. $CurrUserHistory`
Cache: .......................... $CurrUserInetCache`
Cookies: ........................ $CurrUserInetCookies`
TMP (Temp-Folder): .............. $CurrUserTMP`
TEMP (Temp-Folder): ............. $CurrUserTEMP`
`
\--------------------------/" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append

Write-Host "------------------------------------------------------------------`r`n"
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Write-Output "--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
#
# -------------------  User Folder Paths / Benutzerordner Pfade ---------------- END -------------------
#

#
Write-Host "User Certificates / Benutzer Zertifikate`n"
Write-Output "------ User Certificates / Benutzer Zertifikate ------ START -----" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
#
Get-ChildItem Cert:\CurrentUser\My | Select-Object PolicyId,Subject,Issuer,Thumbprint,Version,Handle,NotBefore,NotAfter | Format-List | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
#
Write-Host "------------------------------------------------------------------`r`n"
write-Output "`n`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
Write-Output "--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--/--\--`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append

# ---- Ausgabe --- END ------ 
#
$DateTXT = Get-Date -format "dd.MM.yyyy - HH:mm:ss tt"
Write-Output "------------------------------------------------------------------" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "Erfassung abgeschlossen: $DateTXT" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "------------------------------------------------------------------`r`n" | Out-File "$ExportPath\$ExportFile" -Encoding utf8 -Append
Write-Output "_______________ - End of File - ______________________`r`n" | Out-File -FilePath $ExportPath\$ExportFile -Encoding utf8 -Append
#
# Get-Content $ExportPath\$ExportFile
# pause
Start-Process notepad.exe $ExportPath\$ExportFile
